<?php

include_once('stopforumspam.php');
include_once('constants.php');

// connect to mysql database
$con = mysqli_connect(DATABASE_HOST, DATABASE_USERNAME, DATABASE_PASSWORD, DATABASE_NAME);

// define variable sql string type.
$sql = '';

if (mysqli_connect_errno())
{
	die('Could not connect: ' . mysqli_connect_error());
}

// delete user's inactive records for whom the active records resides in the DB
$sql = "select u1.`email_login`, group_concat(u1.`userid`) AS inactive_userid_strings
from users u1 join 
	(select `email_login` from users where `rec_status` = 1 )as u2 
on u1.`email_login` = u2.`email_login` 
where u1.`rec_status`=-1 group by u1.`email_login`";

$result = mysqli_query($con, $sql);

$userIdArray = array();

while ($row = mysqli_fetch_array($result)) {

	$arrayCreatedAfterExplode = explode(',', $row['inactive_userid_strings']);
	
	array_push($userIdArray, $arrayCreatedAfterExplode);
}

// collect all user ids that are spammers
$sql = "SELECT * FROM users where rec_status = -1";

$result = mysqli_query($con, $sql);

$spamUserIdArray = array();

while ($row = mysqli_fetch_array($result)) {

	$sfs = new StopForumSpam();
	$args = array('email' => $row['email_login']);
	$spamcheck = $sfs->is_spammer( $args );
	
	if ($spamcheck['known']) {
	
		array_push($spamUserIdArray, $row['userid']);
	}
}

$userIdsToDeleteArray = array_merge($userIdArray, $spamUserIdArray);

foreach ($userIdsToDeleteArray as $array) {
	
	if (is_array($array)) {
		
		foreach ($array as $arr) {
		
			deleteAllRecordsForUserId($arr, $con);
		}
	}
	else {
	
		deleteAllRecordsForUserId($array, $con);
	}
}

function deleteAllRecordsForUserId($userId, $con)
{
	// initialize flag
	$allQueryExecutedSuccessfully = TRUE;

	mysqli_query($con, "START TRANSACTION");

	$sql = "DELETE FROM users
		WHERE userid = $userId && rec_status = -1";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from users table';
	}

	$sql = "DELETE FROM folders
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {
		echo '<br />successfully deleted from folders table';
	}

	$sql = "DELETE FROM resource
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {
		echo '<br />successfully deleted from resource table';
	}

	$sql = "DELETE FROM person
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {
		echo '<br />successfully deleted from person table';
	}

	$sql = "DELETE FROM contact
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {
		echo '<br />successfully deleted from contact table';
	}

	$sql = "DELETE FROM document
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {
		echo '<br />successfully deleted from document table';
	}

	$sql = "DELETE FROM medication
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from medication table';
	}

	$sql = "DELETE FROM post
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from post table';
	}

	$sql = "DELETE FROM task
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from task table';
	}

	$sql = "DELETE FROM events
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from events table';
	}

	$sql = "DELETE FROM provider
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from providers table';
	}

	$sql = "DELETE FROM resource_type
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from resource_type table';
	}

	$sql = "DELETE FROM beta_feedback_info
		WHERE userid_created = $userId";

	if (!mysqli_query($con, $sql)) {

		$allQueryExecutedSuccessfully = FALSE;
	}
	else {

		echo '<br />successfully deleted from beta_feedback_info table';
	}

	if (!$allQueryExecutedSuccessfully) {
		
		// roll back
		if (mysqli_query($con, "ROLLBACK"))
		{
			echo 'Transaction successfully rolled back.';
		}
	}
	else {

		// commit the transaction
		if (mysqli_query($con, "COMMIT"))
		{
			echo '<br />Transaction successfully committed';
		}
	}
}

mysqli_close($con);

?>